// From Nano for Addd & xm__
// at 2011-05-15
// http://forum.rudtp.ru/showthread.php?t=44172

// guides2path.jsx
// The Adobe Photoshop javascript

// This script create new path, contained 
// lines for every guide in current document

// Save the current preferences 
var startRulerUnits = app.preferences.rulerUnits;

// Set Photoshop to use pixels
app.preferences.rulerUnits = Units.PIXELS;

var 
    guides = app.activeDocument.guides,
    width = Number(app.activeDocument.width),
    height = Number(app.activeDocument.height),
    subPaths = [];

for (var i = guides.length; i--;) {
    var 
        guide = guides[i], 
        coordinate = Number(guide.coordinate),
        linePathPoints = []; 
       
    // Create one line (with two points) for every guide
    linePathPoints[0] = new PathPointInfo;
    linePathPoints[0].kind = PointKind.CORNERPOINT;
    linePathPoints[1] = new PathPointInfo;
    linePathPoints[1].kind = PointKind.CORNERPOINT;
    
    if (guide.direction == Direction.HORIZONTAL) {
        linePathPoints[0].anchor = [0, coordinate];
        linePathPoints[1].anchor = [width, coordinate];
    } else { // this vertical guide
        linePathPoints[0].anchor = [coordinate, 0];
        linePathPoints[1].anchor = [coordinate, height];
    }
    linePathPoints[0].leftDirection = linePathPoints[0].anchor;
    linePathPoints[0].rightDirection = linePathPoints[0].anchor;
    linePathPoints[1].leftDirection = linePathPoints[1].anchor;
    linePathPoints[1].rightDirection = linePathPoints[1].anchor;

    var subPath = new SubPathInfo();
    subPath.operation = ShapeOperation.SHAPEXOR;
    subPath.closed = false;
    subPath.entireSubPath = linePathPoints;
    
    subPaths.push(subPath);
}

//create the path item
var pathItem = app.activeDocument.pathItems.add(
    'Saved Guides', // name
    subPaths
);

// Reset the application preferences
app.preferences.rulerUnits = startRulerUnits;
